// Copyright lowRISC contributors.
// Licensed under the Apache License, Version 2.0, see LICENSE for details.
// SPDX-License-Identifier: Apache-2.0
//
// Register Package auto-generated by `reggen` containing data structure

package rstmgr_reg_pkg;

  // Param list
  parameter int RdWidth = 32;
  parameter int IdxWidth = 4;
  parameter int NumHwResets = 4;
  parameter int NumSwResets = 8;
  parameter int NumAlerts = 2;

  // Address widths within the block
  parameter int BlockAw = 6;

  ////////////////////////////
  // Typedefs for registers //
  ////////////////////////////

  typedef struct packed {
    struct packed {
      logic        q;
      logic        qe;
    } fatal_fault;
    struct packed {
      logic        q;
      logic        qe;
    } fatal_cnsty_fault;
  } rstmgr_reg2hw_alert_test_reg_t;

  typedef struct packed {
    logic [3:0]  q;
  } rstmgr_reg2hw_reset_req_reg_t;

  typedef struct packed {
    struct packed {
      logic        q;
    } sw_reset;
    struct packed {
      logic [3:0]  q;
    } hw_req;
  } rstmgr_reg2hw_reset_info_reg_t;

  typedef struct packed {
    struct packed {
      logic        q;
    } en;
    struct packed {
      logic [3:0]  q;
    } index;
  } rstmgr_reg2hw_alert_info_ctrl_reg_t;

  typedef struct packed {
    struct packed {
      logic        q;
    } en;
    struct packed {
      logic [3:0]  q;
    } index;
  } rstmgr_reg2hw_cpu_info_ctrl_reg_t;

  typedef struct packed {
    logic        q;
  } rstmgr_reg2hw_sw_rst_regwen_mreg_t;

  typedef struct packed {
    logic        q;
    logic        qe;
  } rstmgr_reg2hw_sw_rst_ctrl_n_mreg_t;

  typedef struct packed {
    logic [3:0]  d;
    logic        de;
  } rstmgr_hw2reg_reset_req_reg_t;

  typedef struct packed {
    struct packed {
      logic        d;
      logic        de;
    } low_power_exit;
    struct packed {
      logic        d;
      logic        de;
    } ndm_reset;
    struct packed {
      logic        d;
      logic        de;
    } sw_reset;
    struct packed {
      logic [3:0]  d;
      logic        de;
    } hw_req;
  } rstmgr_hw2reg_reset_info_reg_t;

  typedef struct packed {
    struct packed {
      logic        d;
      logic        de;
    } en;
  } rstmgr_hw2reg_alert_info_ctrl_reg_t;

  typedef struct packed {
    logic [3:0]  d;
  } rstmgr_hw2reg_alert_info_attr_reg_t;

  typedef struct packed {
    logic [31:0] d;
  } rstmgr_hw2reg_alert_info_reg_t;

  typedef struct packed {
    struct packed {
      logic        d;
      logic        de;
    } en;
  } rstmgr_hw2reg_cpu_info_ctrl_reg_t;

  typedef struct packed {
    logic [3:0]  d;
  } rstmgr_hw2reg_cpu_info_attr_reg_t;

  typedef struct packed {
    logic [31:0] d;
  } rstmgr_hw2reg_cpu_info_reg_t;

  typedef struct packed {
    logic        d;
  } rstmgr_hw2reg_sw_rst_ctrl_n_mreg_t;

  typedef struct packed {
    struct packed {
      logic        d;
      logic        de;
    } reg_intg_err;
    struct packed {
      logic        d;
      logic        de;
    } reset_consistency_err;
  } rstmgr_hw2reg_err_code_reg_t;

  // Register -> HW type
  typedef struct packed {
    rstmgr_reg2hw_alert_test_reg_t alert_test; // [46:43]
    rstmgr_reg2hw_reset_req_reg_t reset_req; // [42:39]
    rstmgr_reg2hw_reset_info_reg_t reset_info; // [38:34]
    rstmgr_reg2hw_alert_info_ctrl_reg_t alert_info_ctrl; // [33:29]
    rstmgr_reg2hw_cpu_info_ctrl_reg_t cpu_info_ctrl; // [28:24]
    rstmgr_reg2hw_sw_rst_regwen_mreg_t [7:0] sw_rst_regwen; // [23:16]
    rstmgr_reg2hw_sw_rst_ctrl_n_mreg_t [7:0] sw_rst_ctrl_n; // [15:0]
  } rstmgr_reg2hw_t;

  // HW -> register type
  typedef struct packed {
    rstmgr_hw2reg_reset_req_reg_t reset_req; // [103:99]
    rstmgr_hw2reg_reset_info_reg_t reset_info; // [98:88]
    rstmgr_hw2reg_alert_info_ctrl_reg_t alert_info_ctrl; // [87:86]
    rstmgr_hw2reg_alert_info_attr_reg_t alert_info_attr; // [85:82]
    rstmgr_hw2reg_alert_info_reg_t alert_info; // [81:50]
    rstmgr_hw2reg_cpu_info_ctrl_reg_t cpu_info_ctrl; // [49:48]
    rstmgr_hw2reg_cpu_info_attr_reg_t cpu_info_attr; // [47:44]
    rstmgr_hw2reg_cpu_info_reg_t cpu_info; // [43:12]
    rstmgr_hw2reg_sw_rst_ctrl_n_mreg_t [7:0] sw_rst_ctrl_n; // [11:4]
    rstmgr_hw2reg_err_code_reg_t err_code; // [3:0]
  } rstmgr_hw2reg_t;

  // Register offsets
  parameter logic [BlockAw-1:0] RSTMGR_ALERT_TEST_OFFSET = 6'h 0;
  parameter logic [BlockAw-1:0] RSTMGR_RESET_REQ_OFFSET = 6'h 4;
  parameter logic [BlockAw-1:0] RSTMGR_RESET_INFO_OFFSET = 6'h 8;
  parameter logic [BlockAw-1:0] RSTMGR_ALERT_REGWEN_OFFSET = 6'h c;
  parameter logic [BlockAw-1:0] RSTMGR_ALERT_INFO_CTRL_OFFSET = 6'h 10;
  parameter logic [BlockAw-1:0] RSTMGR_ALERT_INFO_ATTR_OFFSET = 6'h 14;
  parameter logic [BlockAw-1:0] RSTMGR_ALERT_INFO_OFFSET = 6'h 18;
  parameter logic [BlockAw-1:0] RSTMGR_CPU_REGWEN_OFFSET = 6'h 1c;
  parameter logic [BlockAw-1:0] RSTMGR_CPU_INFO_CTRL_OFFSET = 6'h 20;
  parameter logic [BlockAw-1:0] RSTMGR_CPU_INFO_ATTR_OFFSET = 6'h 24;
  parameter logic [BlockAw-1:0] RSTMGR_CPU_INFO_OFFSET = 6'h 28;
  parameter logic [BlockAw-1:0] RSTMGR_SW_RST_REGWEN_OFFSET = 6'h 2c;
  parameter logic [BlockAw-1:0] RSTMGR_SW_RST_CTRL_N_OFFSET = 6'h 30;
  parameter logic [BlockAw-1:0] RSTMGR_ERR_CODE_OFFSET = 6'h 34;

  // Reset values for hwext registers and their fields
  parameter logic [1:0] RSTMGR_ALERT_TEST_RESVAL = 2'h 0;
  parameter logic [0:0] RSTMGR_ALERT_TEST_FATAL_FAULT_RESVAL = 1'h 0;
  parameter logic [0:0] RSTMGR_ALERT_TEST_FATAL_CNSTY_FAULT_RESVAL = 1'h 0;
  parameter logic [3:0] RSTMGR_ALERT_INFO_ATTR_RESVAL = 4'h 0;
  parameter logic [3:0] RSTMGR_ALERT_INFO_ATTR_CNT_AVAIL_RESVAL = 4'h 0;
  parameter logic [31:0] RSTMGR_ALERT_INFO_RESVAL = 32'h 0;
  parameter logic [31:0] RSTMGR_ALERT_INFO_VALUE_RESVAL = 32'h 0;
  parameter logic [3:0] RSTMGR_CPU_INFO_ATTR_RESVAL = 4'h 0;
  parameter logic [3:0] RSTMGR_CPU_INFO_ATTR_CNT_AVAIL_RESVAL = 4'h 0;
  parameter logic [31:0] RSTMGR_CPU_INFO_RESVAL = 32'h 0;
  parameter logic [31:0] RSTMGR_CPU_INFO_VALUE_RESVAL = 32'h 0;
  parameter logic [7:0] RSTMGR_SW_RST_CTRL_N_RESVAL = 8'h ff;
  parameter logic [0:0] RSTMGR_SW_RST_CTRL_N_VAL_0_RESVAL = 1'h 1;
  parameter logic [0:0] RSTMGR_SW_RST_CTRL_N_VAL_1_RESVAL = 1'h 1;
  parameter logic [0:0] RSTMGR_SW_RST_CTRL_N_VAL_2_RESVAL = 1'h 1;
  parameter logic [0:0] RSTMGR_SW_RST_CTRL_N_VAL_3_RESVAL = 1'h 1;
  parameter logic [0:0] RSTMGR_SW_RST_CTRL_N_VAL_4_RESVAL = 1'h 1;
  parameter logic [0:0] RSTMGR_SW_RST_CTRL_N_VAL_5_RESVAL = 1'h 1;
  parameter logic [0:0] RSTMGR_SW_RST_CTRL_N_VAL_6_RESVAL = 1'h 1;
  parameter logic [0:0] RSTMGR_SW_RST_CTRL_N_VAL_7_RESVAL = 1'h 1;

  // Register index
  typedef enum int {
    RSTMGR_ALERT_TEST,
    RSTMGR_RESET_REQ,
    RSTMGR_RESET_INFO,
    RSTMGR_ALERT_REGWEN,
    RSTMGR_ALERT_INFO_CTRL,
    RSTMGR_ALERT_INFO_ATTR,
    RSTMGR_ALERT_INFO,
    RSTMGR_CPU_REGWEN,
    RSTMGR_CPU_INFO_CTRL,
    RSTMGR_CPU_INFO_ATTR,
    RSTMGR_CPU_INFO,
    RSTMGR_SW_RST_REGWEN,
    RSTMGR_SW_RST_CTRL_N,
    RSTMGR_ERR_CODE
  } rstmgr_id_e;

  // Register width information to check illegal writes
  parameter logic [3:0] RSTMGR_PERMIT [14] = '{
    4'b 0001, // index[ 0] RSTMGR_ALERT_TEST
    4'b 0001, // index[ 1] RSTMGR_RESET_REQ
    4'b 0001, // index[ 2] RSTMGR_RESET_INFO
    4'b 0001, // index[ 3] RSTMGR_ALERT_REGWEN
    4'b 0001, // index[ 4] RSTMGR_ALERT_INFO_CTRL
    4'b 0001, // index[ 5] RSTMGR_ALERT_INFO_ATTR
    4'b 1111, // index[ 6] RSTMGR_ALERT_INFO
    4'b 0001, // index[ 7] RSTMGR_CPU_REGWEN
    4'b 0001, // index[ 8] RSTMGR_CPU_INFO_CTRL
    4'b 0001, // index[ 9] RSTMGR_CPU_INFO_ATTR
    4'b 1111, // index[10] RSTMGR_CPU_INFO
    4'b 0001, // index[11] RSTMGR_SW_RST_REGWEN
    4'b 0001, // index[12] RSTMGR_SW_RST_CTRL_N
    4'b 0001  // index[13] RSTMGR_ERR_CODE
  };

endpackage

